/**************************************************************************************************
 *
 *	lastplace.c
 *
 *	part of the layout program.
 *
 *
 *	Written by Gerard Leurs, NIKHEF-H, Amsterdam.
 *	July 1991.
 *	a89@nikhef.nl
 *
 *************************************************************************************************/

# include "layout.h"

	/* replace the more_links_nodes with only one connection to another more_links_node */
	/* replace the more_links_node with two connections to other more_links_nodes */

extern void place_node_1_and_2(try_to_adjust)
int try_to_adjust;		/* make more checks on coordinates */
{
	struct hostentity * dummyhost1;		/* node to check */
	struct hostentity * dummyhost2;		/* other nodes */
	int links;				/* number of links for the node to check */
	int x1, y1, w1, h1;			/* coordinates and sizes for the first more_links_node a node-2-links is connected to */
	int x2, y2, w2, h2;			/* coordinates and sizes for the second more_links_node a node-2-links is connected to */
	int x1_center, y1_center, x2_center, y2_center;		/* midpoint of the 2 connecting more_links_node */
	int x, y;				/* coordinates for the two_link_node determined by check_overlap */
	char first[MaxEnt];			/* name of the first node connected to */


	dummyhost1 = host;

	while (dummyhost1 != NULL)
	{
		links = 0;

		dummyhost2 = host;
		while (dummyhost2 != NULL)
		{
			if ( ((strcmp(dummyhost1->hostname,dummyhost2->hostname)) != 0)
			   && (linked_or_not(dummyhost1->id,dummyhost2->id)) )
				links++;

			dummyhost2 = dummyhost2->next;
		}

		/* get more_links_nodes with only one link to another more_links_node */
		/* change coordinates for these nodes (only if possible) */

		if (links == 1)
		{
			dummyhost2 = host;
			while (dummyhost2 != NULL)
			{
				if ( ((strcmp(dummyhost1->hostname,dummyhost2->hostname)) != 0)
				   && (linked_or_not(dummyhost1->id,dummyhost2->id)) )
				{
					check_overlap_1(dummyhost1, dummyhost2, &x, &y);
					if ((x != -100) && (y != -100))
					{
						dummyhost1->x_coord = x;
						dummyhost1->y_coord = y;
					}
				}

				dummyhost2 = dummyhost2->next;
			}
		}

		/* get more_links_nodes with only one link to another more_links_node */
		/* when possible (causing no overlap) change coordinates for these nodes */

		if (links == 2)
		{
			strcpy(first,"what_a_strange_name_for_a_node");
			dummyhost2 = host;
			while (dummyhost2 != NULL)
			{
				if ( ((strcmp(dummyhost1->hostname,dummyhost2->hostname)) != 0)
				   && (linked_or_not(dummyhost1->id,dummyhost2->id)) )
				{
					if ((strcmp(first,"what_a_strange_name_for_a_node")) == 0)
					{
						strcpy(first,dummyhost2->hostname);
						x1 = dummyhost2->x_coord;	y1 = dummyhost2->y_coord;
						w1 = dummyhost2->width;		h1 = dummyhost2->height;
					}
					else
					{
						x2 = dummyhost2->x_coord;	y2 = dummyhost2->y_coord;
						w2 = dummyhost2->width;		h2 = dummyhost2->height;
					}
				}

				dummyhost2 = dummyhost2->next;
			}
			nearest_point(x1,x2, w1, w2, &x1_center, &x2_center);
			nearest_point(y1,y2, h1, h2, &y1_center, &y2_center);

		/* check overlap for the new coordinates */

			check_overlap_2(dummyhost1, x1_center, x2_center, y1_center, y2_center, &x, &y, try_to_adjust);
			if ((x != -100) && (y != -100))
			{
				dummyhost1->x_coord = x;
				dummyhost1->y_coord = y;
			}
		}

		dummyhost1 = dummyhost1->next;
	}
}


	/* allign connecting nodes so the layout looks nice */

extern void allign_nodes()
{
	struct hostentity * dummyhost1;
	struct hostentity * dummyhost2;

	dummyhost1 = host;
	while (dummyhost1 != NULL)
	{
		dummyhost2 = host;
		while (dummyhost2 != NULL)
		{
			if ( ((strcmp(dummyhost1->hostname,dummyhost2->hostname)) != 0)
			   && (linked_or_not(dummyhost1->id,dummyhost2->id)) )
			{
				if ( ((dummyhost1->x_coord - dummyhost2->x_coord) <= (2 * DEFAULTheight))
				  && ((dummyhost1->x_coord - dummyhost2->x_coord) > 0) )
				{
					dummyhost1->x_coord -= (dummyhost1->x_coord - dummyhost2->x_coord) / 2;
					dummyhost2->x_coord += (dummyhost1->x_coord - dummyhost2->x_coord) / 2;
				}
				if ( ((dummyhost1->y_coord - dummyhost2->y_coord) <= (2 * DEFAULTheight))
				  && ((dummyhost1->y_coord - dummyhost2->y_coord) > 0) )
				{
					dummyhost1->y_coord -= (dummyhost1->y_coord - dummyhost2->y_coord) / 2;
					dummyhost2->y_coord += (dummyhost1->y_coord - dummyhost2->y_coord) / 2;
				}
			}

			dummyhost2 = dummyhost2->next;
		}

		dummyhost1 = dummyhost1->next;
	}
}
