/**************************************************************************************************
 *
 *	layout.h
 *
 *	part of the layout program.
 *
 *
 *	Written by Gerard Leurs, NIKHEF-H, Amsterdam.
 *	July 1991.
 *	email: a89@nikhef.nl
 *
 *************************************************************************************************/

# include <stdio.h>
# include <ctype.h>
# include <time.h>
# include <math.h>

# define MaxEnt	   96			/* maximum length of hostnames */
# define MaxLine 1024			/* maximum length of one line in the input */
# define FALSE	    0
# define TRUE	    1
# define NONSENSE  10			/* "values" for unknown-nodes */

extern int Debug;			/* print statistics/jobs */
extern int number_of_nodes;		/* keep track of total hosts - networks */
extern int WINDOWwidth;			/* x-size of the window (default) */
extern int WINDOWheight;		/* y-size of the window (default) */
extern int DEFAULTwidth;		/* width for nodes with originally zero width */
extern int DEFAULTheight;		/* height for nodes with originally zero height */
extern int boundary;			/* surrounding area in window, used for unlinked nodes */

struct hostentity			/* node structure declaration */
{
	char id[MaxEnt];
	char hostname[MaxEnt];
	int x_coord;
	int y_coord;
	int width;
	int height;
	int link;
	struct hostentity *next;
} ;

struct linkentity			/* link structure declaration */
{
	char linktype[MaxEnt];
	char id_one[MaxEnt];
	char id_two[MaxEnt];
	struct linkentity *next;
} ;

extern struct hostentity *host;			/* name of the node structure */
extern struct hostentity *host_zero_links;	/* structurename with nodes without links */
extern struct hostentity *host_one_link;	/* structurename with nodes with only one links */
extern struct hostentity *host_more_to_one;	/* structurename with nodes with more links, but only to nodes with one link */

extern struct hostentity * addnodestructure();

extern struct linkentity *link;			/* name of the link structure */

extern struct linkentity * addlinkstructure();

extern float links_nodes();
extern int get_characteristics();
extern int linked_or_not();
extern int check_nodes();
