/**************************************************************************************************
 *
 *	links.c
 *
 *	part of the layout program.
 *
 *
 *	Written by Gerard Leurs, NIKHEF-H, Amsterdam.
 *	July 1991.
 *	email: a89@nikhef.nl
 *
 *************************************************************************************************/

# include "layout.h"

	/* determination if two nodenames are linked or not
	   returns FALSE if not linked and returns TRUE if linked */

extern int linked_or_not(hostid_one,hostid_two)
char hostid_one[MaxEnt];			/* the name of the first node we are looking for */
char hostid_two[MaxEnt];			/* the name of the second node we are looking for */
{
	struct linkentity * dummylink1;		/* structure to be searched */

	dummylink1 = link;
	while (dummylink1 != NULL)
	{
		if ( ( (strcmp(hostid_one,dummylink1->id_one) == 0 )
		    && (strcmp(hostid_two,dummylink1->id_two) == 0 ) )
		  || ( (strcmp(hostid_one,dummylink1->id_two) == 0 )
		    && (strcmp(hostid_two,dummylink1->id_one) == 0 ) ) )
			return TRUE;

		dummylink1 = dummylink1->next;
	}
	return FALSE;
}


	/* how many links are possible between all processed nodes
	   return the ratio of possible links / nodes (more linked ones only) */

extern float links_nodes(number)
int number;			/* total number of nodes */
{
	int sum = 0;		/* total of possible links */
	int savethis = number;

	while (number-- > 0)
		sum += number;
	return (float) ((sum / savethis));
}
