/******************************************************************/
/******************************************************************/
/*  $Header$  */
/******************************************************************/
/*  X11 drawing stuff, for drawing maps interactively  */
/******************************************************************/

#include "xmonet.h"

/******************************************************************/
/*  Undraw a system before making a change to its status          */
/******************************************************************/

static void draw (s, moved)
	Drawing         s;
	Boolean		moved;
{
	Map map, m;

	if ((map = Drawing_mapOf(s)) == NULL) {
		sys_error ("Map is NULL");
		return;
	}
	m = map;
	while (m->parent)
		m = Drawing_mapOf(m -> parent);

	if ( ! isDrawingAllowed ()) {
		/* Don't draw anything just now */
	} else if ((map = Drawing_mapOf(s)) == NULL) {
		sys_error ("Map is NULL");
	} else if ( ! Map_widget(map)) {
		sys_error ("Map with null map widget [%s], drawing [%s]", Map_title (map), Drawing_title (s));
	} else if (start_draw_X11 (Map_widget(map), m->scale, NULL, False)) {
		Drawing_draw (s, map, moved);
	}
}

/******************************************************************/
/*  Undraw a system a system before making changes to its state    */
/******************************************************************/

extern void Drawing_undraw(s)
	Drawing          s;
{
	draw (s, True);
}

extern void Drawing_unmoved_undraw (s)
	Drawing          s;
{
	draw (s, False);
}

/******************************************************************/
/*  Redraw a system a system after making changes to its state    */
/******************************************************************/

extern void Drawing_unmoved_redraw (s)
	Drawing          s;
{
	draw (s, False);
}

extern void Drawing_redraw(s)
	Drawing          s;
{
	draw (s, True);
}

/******************************************************************/
/******************************************************************/
/*  $Header$  */
/******************************************************************/
/******************************************************************/

