/*****************************************************************************/
/*****************************************************************************/
/* $Header: //gaia/group.local/computer/monet/Xmonet/RCS/main.c,v 1.1 1991/03/26 12:00:14 a38 Exp a38 $ */
/*****************************************************************************/
/*****************************************************************************/

#include "xmonet.h"
#include "bitmap/Icons.h"

/*****************************************************************************/
/*  Destroy everything created, ready to start afresh */
/*  I'll be bloody suprised if this works just now !!! */
/*****************************************************************************/

static void finish_system ()
{
	ClassDrawing_finish ();
	finish_drawMaps();
	Monet_finish ();
}

/*****************************************************************************/
/*  The top */
/*****************************************************************************/

main(argc, argv)
	int             argc;
	char           **argv;
{
	/* -- Start up basic monet stuff, read config files */
	Monet_init ("xmonet", finish_system, argc, argv);

	user_inform ("Interface defined in XMonet.ad, must be available!");
	user_inform ("if it doesn't work try, xrdb XMonet.ad");

	/* -- Start X stuff  */
	if ( ! XMonet_init ("XMonet", argc, argv)) {
		exit (1);
	}
	/*  -- Init map library, this also initialises the entity database  */
	ClassMap_init (Map_changed_handler);

	/*  -- Register all application specific callbacks and widget classes */
	MapCB_init ();

	/*  -- Create widget tree below toplevel shell using Xrm database */
	WcWidgetCreation ( toplevel );

	/*  -- Realize the widget tree */
	XtRealizeWidget ( toplevel );

	/*  -- Set up the icon pixmap */
	{
		Widget w;
		Pixmap icon;
		Arg tmp_arg[2];
		icon = XCreateBitmapFromData(display, XtWindow(toplevel),
				 monet_icon_bits, monet_icon_width, monet_icon_height);
		XtSetArg(tmp_arg[0], XtNiconPixmap, icon);
		XtSetValues(toplevel, tmp_arg, ONE);
		if (w = WcFullNameToWidget( toplevel, "XMonet*print_map" )) {
			icon = XCreateBitmapFromData(display, XtWindow(toplevel),
				 psprint_bits, psprint_width, psprint_height);
			XtSetArg(tmp_arg[0], XtNlabel, NULL);
			XtSetArg(tmp_arg[1], XtNbitmap, icon);
			XtSetValues(w, tmp_arg, 2);
		} else {
			sys_error ("No such widget");
		}
	}
	copyright_message ();
	/* !!! Hack to draw class maps  */
/*	ClassMap_redraw_all (); */

	/*  -- Execute a startup monet script */
	Script_execute (Config_startup_command);

	/*  -- Popup a welcome widget  */
	PopupCentralCB(toplevel, "XMonet.welcome", NULL);

	/*  -- enter the main application loop */

	XMonet_EventLoop ();

	MapCB_finish ();
	ClassEntity_finish ();
	finish_frontend ();

	XtDestroyApplicationContext (app_con);
	XtCloseDisplay (display);
	Monet_finish ();

	return 0;
}

/*****************************************************************************/
/*****************************************************************************/
/* $Header: //gaia/group.local/computer/monet/Xmonet/RCS/main.c,v 1.1 1991/03/26 12:00:14 a38 Exp a38 $ */
/*****************************************************************************/
/*****************************************************************************/

