#ifndef MONET_DB_CLASS_H
#define MONET_DB_CLASS_H

typedef struct class_data	* EntityClassData;

/***************************************************************************/
/*  A list of standard attributes   s                                      */
/***************************************************************************/

typedef struct {
	AttributeID
		format,
		emphasis,
		resizable,
		map,
		shape,
		ping,
		status,
		anonymous,
		underlying,
		unbendingInterface,
		instances,
		title;
	} StandardAttributes;

extern StandardAttributes Std_Attribute;

/***************************************************************************/
/*  Function Prototypes  */
/***************************************************************************/

#ifdef MONET_PROTOTYPES

extern void	init_class		(void);
extern void	finish_class		(void);
extern Boolean	isInterfaceClass	(Entity);

/*  These are all of type AttributeRoutine  */
extern String set_titleFormat		(Entity,  AttributeOperation, AttributeFormat, String);
extern String set_anonymous_name	(Entity,  AttributeOperation, AttributeFormat, String);
extern String set_instances		(Entity,  AttributeOperation, AttributeFormat, String);
extern String set_interfaceClass	(Entity,  AttributeOperation, AttributeFormat, String);
extern String set_systemClass		(Entity,  AttributeOperation, AttributeFormat, String);
extern String set_noset_instances	(Entity,  AttributeOperation, AttributeFormat, String);
extern String set_mapClass		(Entity,  AttributeOperation, AttributeFormat, String);
extern String set_underlying		(Entity,  AttributeOperation, AttributeFormat, String);
extern String set_titleFormat		(Entity,  AttributeOperation, AttributeFormat, String);
extern String set_shape			(Entity,  AttributeOperation, AttributeFormat, String);
extern String set_unbendingInterface	(Entity,  AttributeOperation, AttributeFormat, String);
extern String access_ping		(Entity,  AttributeOperation, AttributeFormat, String);
extern String set_translation		(Entity,  AttributeOperation, AttributeFormat, String);

extern String	get_ping_instruction	(Entity);
extern Shape	shapeOf_entity	(Entity);
extern Boolean	isBendingInterface	(Entity);
extern Entity	get_fromClass		(Entity);
extern Entity	get_toClass		(Entity);
extern Boolean	isPingable		(Entity);
extern Boolean	has_anonymous_name	(Entity);
extern Boolean	no_instances_allowed	(Entity);

#else

extern void	init_class		();
extern void	finish_class		();
extern Boolean	isInterfaceClass	();

/*  These are all of type AttributeRoutine  */
extern String set_titleFormat		();
extern String set_anonymous_name	();
extern String set_instances		();
extern String set_interfaceClass	();
extern String set_systemClass		();
extern String set_noset_instances	();
extern String set_mapClass		();
extern String set_underlying		();
extern String set_titleFormat		();
extern String set_shape			();
extern String set_unbendingInterface	();
extern String access_ping		();
extern String set_translation		();

extern String	get_ping_instruction	();
extern Shape	shapeOf_entity	();
extern Boolean	isBendingInterface	();
extern Entity	get_fromClass		();
extern Entity	get_toClass		();
extern Boolean	isPingable		();
extern Boolean	has_anonymous_name	();
extern Boolean	no_instances_allowed	();

#endif /* MONET_PROTOTYPES */






#endif

