.TH LIBMONETDB 3N "Release 0.2-Beta"
.\" $Header$
.\"
.\"
.\" $Log$
.\" 
.SH NAME
libmonetdb \- Monet Network Entity Library
.SH SYNOPSIS
.B "#include <monet/db/Entity.h>"
.sp
\fIcc\fR\0...\0\fB\-lmonetdb\fR
.SH DESCRIPTION
The \fIlibmonetdb\fR library contains a set of routines which implement
a distributed database for network entities.
.PP
The database model is a stack of related networks.  Each layer in the stack
represents one set of network protocols.  This is very similar to the idea
use din the OSI reference model.
Links between entities in the same layer are called \fIinterfaces\fR and
these connect exactly two entities.
Links between entities on different layers is done saying one set of
entities are components of enother entity.
Entities themselves are a set of attributes, each with a value.
In addition each entitiy has a class which gives a general description
of a set of entities.  Examples of classes are \fIEthernet's\fR or
\fIip networks\fR.  Entities inherit the attributes of its class.
.PP
The library constists of four parts,
.TP 4
.B Database management
classes, attributes and entities.
.TP 4
.B Relationships between entities
interfaces and components.
.TP 4
.B Attribute,
status information and handling changes.  Trigger routines
must be registered with the database, which are called
when the status changes.
.TP 4
.B I/O
External access, parser, info and redirecting queries.
.SH DIAGNOSTICS
Most routines return an indication that did not work,
and will also send a message.
.SH SEE ALSO
monet(1N)
.SH BUGS
Protocol not fully symetrical.
.br
No status history is kept.
.SH AUTHOR
James Barr, NIKHEF-H, Amsterdam

