/**********************************************************/
/**********************************************************/
/* $Header$  */
/**********************************************************/
/*  Files are saved in a special directory and have a     */
/*  user name and version number attached to their name   */
/*  before saving.  These routines convert a simple file  */
/*  name into the actual nameused in the unix filestore.  */
/*  They check the names for correctness and print        */
/*  diagnostics.                                          */
/*                                                        */
/*  !!! No checks are made on the sizes of filenames.     */
/*  !!! Should also deal with quotas for users.           */
/*  !!! Does not deal with version numbers yet.           */
/**********************************************************/

#include "general/General.h"
#include "general/Channel.h"
#include <netdb.h>
#include "general/MapServer.h"

static String map_file_name (name)
	String name;
{
	static char buffer [1024];
	(void) sprintf (buffer, "%s/%s", Config_map_directory, name);
	return (char *) MonetFilename (buffer);
}

/* -- Should avoid this one  */
extern String MapServer_name2filename (name)
	String name;
{
	char  filename[1024]; /* !!! */
	String result;
	int version = 1;

	name = tidy_name (name);
	sprintf (filename, "%d.%s_%s", Config_user_id, version, name);
	result = map_file_name (filename);

	return result;
}

extern String MapServer_filename2name (filename)
	String filename;
{
	String name;

	filename = tidy_name (filename);
	name = index (filename, '_');
	if (name)
		name ++;
	else
		name = filename;
	return name;
}

extern FILE * MapServer_fopen_save (name)
	String name;
{
	char *filename, buff[1024], * file; /* !!! */
	int version=1;
	FILE * result;

	name = tidy_name (name);
	if (MonetStrlen (name) == 0) {
		user_error ("NULL file name");
		return NULL;
	}
	file = index (name, '_');
	if (file == 0) {
		/* User id missing from save command */
		sprintf (buff, "%d.%s_%s", version, Config_user_id, name);
	} else {
		sprintf (buff, "%d.%s", version, name);
	}
	filename = map_file_name (buff);
	if (result = fopen (filename, "w"))
		user_inform ("Opened [%s] for saving", filename);
	else
		user_error ("Could not open file [%s]", filename);
	return result;
}

extern FILE * MapServer_fopen_load (filename)
	String filename;
{
	FILE * result;

	filename = tidy_name (filename);
	filename = map_file_name (filename);
	if (result = fopen (filename, "r"))
		user_inform ("Opened [%s] for loading", filename);
	else
		user_error ("Could not open file [%s]", filename);
	return result;
}


/**********************************************************/
/**********************************************************/
/* $Header$  */
/**********************************************************/
/**********************************************************/

