#ifndef MONET_PRIVATE_SCRIPT_H
#define MONET_PRIVATE_SCRIPT_H

/*  This is a private header file for the script stuff  */

#include "general/General.h"
#include "general/Script.h"

/*****************************************************************************/
/*  Lexical tokens, could maybe better use lex                               */
/*****************************************************************************/

typedef enum {
	lex_statement, lex_name, lex_string, lex_label, lex_int,
	lex_parameter, lex_pipe_parameter,
	/* -- Sequence seperators */
	lex_sep, lex_pipe, lex_and, lex_or,
	/* -- Arithmetic */
	lex_op2,
	/* -- redirect out put to file  */
	lex_pipe_out, lex_pipe_in, 
	/* -- End of commands */
	lex_end
	} LexSymbol;


#ifdef MONET_PROTOTYPES

extern void	Script_init_base (void);
extern void	Script_finish_base (void);
extern String	Script_next_symbol_loose (String * source, LexSymbol * lex);
extern String	Script_next_symbol_tight (String * source, LexSymbol * lex);

#else

extern void	Script_init_base		();
extern void	Script_finish_base		();
extern String	Script_next_symbol_loose	();
extern String	Script_next_symbol_tight	();

#endif

#endif

