/******************************************************************/
/******************************************************************/
/* $Header: //gaia/group.local/computer/monet/Draw/RCS/text.c,v 1.1 1991/03/26 10:52:24 a38 Exp a38 $ */
/******************************************************************/
/******************************************************************/

#include "general/General.h"
#include "general/Draw.h"

/******************************************************************/
/******************************************************************/

DrawLibrary TextLib;

static FILE * DumpFile = NULL;

/******************************************************************/
/******************************************************************/

static void OUT (a,b,c,d,e,f,g,h,i)
	char * a;
{
	fprintf (DumpFile, a,b,c,d,e,f,g,h,i);
	fprintf (DumpFile, "\n");
}

static char * shade2string (shade)
	Shade shade;
{
	char buffer [31];

	(void) sprintf (buffer, "shade%u", shade);
	return buffer;
}

/******************************************************************/
/* Before draing anything on a particular map, this routine must */
/* be called */
/******************************************************************/

extern Boolean start_draw_text (title)
	String title;
{
	char filename [1024]; /* !!! */

	PROC("start_draw_text");

	(void) sprintf (filename, "%s.txt", title);
	DumpFile = fopen (filename, "w");
	if (DumpFile == NULL) {
		user_error ("Could not open file [%s]", filename);
		return False;
	} else {
		user_inform ("Dumping 'text' format map to file [%s]", filename);
	}
	Draw_start_draw (TextLib, 1.0, 1.0);
	return True;
}

static void end_draw ()
{
	fclose (DumpFile);
}

static void 
draw_percentage_line (shade,  n, d, xl, yl, xr, yr)
	Position        xl, yl, xr, yr;
	Shade shade;
	int n , d;
{
	OUT ("draw_percentage_line %s %d%% %d %d %d %d", shade2string (shade), n/d*100, xl,yl, xr,yr);
}

static void 
draw_line (shade,  xl, yl, xr, yr)
	Position        xl, yl, xr, yr;
	Shade shade;
{
	OUT ("draw_line %s %d %d %d %d", shade2string (shade), xl,yl, xr,yr);
}

static void 
fill_elipse (shade, x, y, width, height)
	Shade shade;
	Position        x, y;
	Dimension       width, height;
{
	OUT ("fill_elipse %s %d %d %u %u", shade2string (shade), x,y, width, height);
}

static void 
draw_elipse (shade, x, y, width, height)
	Shade shade;
	Position        x, y;
	Dimension       width, height;
{
	OUT ("draw_elipse %s %d %d %u %u", shade2string (shade), x,y, width, height);
}


static void draw_rectangle (shade, x, y, width, height)
	Shade shade;
	Position        x, y;
	Dimension       width, height;
{
	OUT ("draw_rectangle %s %d %d %u %u", shade2string (shade), x,y, width, height);
}

static void draw_roundedRectangle (shade, x, y, width, height)
	Shade shade;
	Position        x, y;
	Dimension       width, height;
{
	OUT ("draw_rounded_rectangle %s %d %d %u %u", shade2string (shade), x,y, width, height);
}

static void fill_roundedRectangle (shade, x, y, width, height)
	Shade shade;
	Position        x, y;
	Dimension       width, height;
{
	OUT ("fill_rounded_rectangle %s %d %d %u %u", shade2string (shade), x,y, width, height);
}

static void draw_box (shade, x, y, width, height, xspace, yspace)
	Shade shade;
	Position        x, y;
	Dimension       width, height;
{
	OUT ("draw_box %s %d %d %u %u  %u  %u", shade2string (shade), x,y, width, height, xspace, yspace);
}


static void fill_rectangle (shade, x, y, width, height)
	Shade shade;
	Position        x, y;
	Dimension       width, height;
{
	OUT ("fill_rectangle %s %d %d %u %u", shade2string (shade), x,y, width, height);
}

static void 
draw_string (shade, x, y, string)
	Shade shade;
	Position        x, y;
	String string;
{
	OUT ("draw_string %s %d %d (%s)", shade2string (shade), x,y, string);
}

static void  draw_bitmap (id, x,y)
	BitmapId id;
	Position x, y;
{
	OUT ("draw_bitmap %d %d %d ", id, x,y);
}

static void  register_bitmap	(id, w,h, bits)
	BitmapId id;
	Dimension w, h;
	char * bits;
{
}

static void set_scale (x,y)
	float x,y;
{
	OUT ("set_scale %f %f", x,y);
}

static void set_reverse ()
{
	OUT ("set_reverse");
}
/*****************************************************************/
/* Init and finish drawing of entitys */
/*****************************************************************/

extern void 
init_draw_text ()
{
	PROC("init_draw_text");
	NEWDRAWLIB(TextLib);
}

extern void 
finish_draw_text()
{
	MonetFree (TextLib);
	TextLib = NULL;
}

/******************************************************************/
/******************************************************************/
/* $Header: //gaia/group.local/computer/monet/Draw/RCS/text.c,v 1.1 1991/03/26 10:52:24 a38 Exp a38 $ */
/******************************************************************/
/******************************************************************/

