/******************************************************************/
/******************************************************************/
/* $Header$  */
/******************************************************************/
/*  !!! This is a hack that hopefully won't do any damage  */
/*  !!! Created from xio/draw.c, these two files should be */
/*  !!! integrated.  */
/******************************************************************/

#include "general/General.h"
#include "general/Draw.h"

static Scale ScaleList = NULL;

struct scale {
	char name[MAXSCALENAMELEN];
	float x_scale, y_scale;
	Scale next;
};

/*****************************************************************************/
/*  Convert between scale and string  */
/*****************************************************************************/

extern Scale	String2Scale	(string)
	String string;
{
	Dimension width, height;
	Scale scale;
	String name;

	if (string == NULL)
		string = "_default";

	if (EQS(string, "_default")) {
		name   = "6x10";
		width  = BASE_CHAR_WIDTH;
		height = BASE_CHAR_HEIGHT;
	} else if (EQS(string, "_tiny")) {
		name = "micro";
		width  = 1;
		height = 1;
	} else if (EQS(string, "_small")) {
		name   = "5x8";
		width  = 5;
		height = 8;
	} else if (EQS(string, "_large")) {
		name = "9x15";
		width  = 9;
		height = 15;
	} else {
		width = 0;
		name = string;
	}
	/*  Check to see if scale already exists  */
	FORALL(scale, ScaleList, next)
		if (EQS (name, scale->name))
			return scale;

	/*  Create a new Scale with the font  */
	scale = MonetNew (struct scale);
	if ( ! scale) {
		sys_error ("Could not allocate space for Scale");
		return NULL;
	}
	scale -> x_scale = (float) width   / BASE_CHAR_WIDTH;
	scale -> y_scale = (float) height  / BASE_CHAR_HEIGHT;
	(void) strncpy (scale->name, string, MAXSCALENAMELEN - 1);
	scale->name[MAXSCALENAMELEN-1] = NULL;
	LIST_ADD (scale, ScaleList, next);

	return scale;
}

/*****************************************************************************/
/*  Convert between scale and string  */
/*****************************************************************************/

extern String	Scale2String	(scale)
	Scale scale;
{
	if (scale)
		return scale->name;
	else
		return "_default";
}

extern void Scale_xy (scale, x, y)
	Scale scale;
	float *x,*y;
{
	if ( ! scale) {
		*x = 1.0;
		*y = 1.0;
	} else {
		*x =  scale->x_scale;
		*y =  scale->y_scale;
	}
}

/******************************************************************/
/******************************************************************/
/* $Header$  */
/******************************************************************/
/******************************************************************/
