/*************************************************************************/
/*************************************************************************/
/*  $Header$  */
/*************************************************************************/
/*************************************************************************/

#include "general/General.h"
#include "xmonet/Widget.h"

/*************************************************************************/
/*  Globals  */
/*************************************************************************/

static Widget Report_widget = (Widget) 0, Report_label, ReportPopup;

/*************************************************************************/
/*  Write to the report  */
/*************************************************************************/

static void xio_write_report (a,b,c,d,e,f,g,h,i)
	char * a;
{
	if (Report_widget)
		write_widget (Report_widget, a,b,c,d,e,f,g,h,i);
	else {
		printf ("[Report] ");
		printf (a,b,c,d,e,f,g,h,i);
	}
}

/*************************************************************************/
/*  Popdown the report widget  */
/*************************************************************************/

static void PopdownReport (button, client_data, call_data)
Widget button;
XtPointer client_data, call_data;
{
	XtPopdown (ReportPopup);
}


/*************************************************************************/
/*  Create the report form  */
/*************************************************************************/

extern void create_report_form (parent)
	Widget parent;
{
	Arg args[6];
	Widget box;
	PROC ("create_report_form");

	ReportPopup = XtCreatePopupShell ("popup_report_form", transientShellWidgetClass, parent, args, 0);
	box =  XtCreateManagedWidget ("report", panedWidgetClass, ReportPopup, args,0);
	Report_label =  XtCreateManagedWidget ("No Report", commandWidgetClass, box, args,0);
	XtAddCallback(Report_label, XtNcallback, PopdownReport, NULL);

#ifdef X11R4
XtSetArg (args[0], XtNeditType, XawtextEdit);
XtSetArg (args[1], XtNscrollVertical, True);
XtSetArg (args[2], XtNscrollHorizontal, True);
XtSetArg (args[3], XtNheight, 150);
	XtSetArg (args[4], XtNwidth, 400);  
	Report_widget =  XtCreateManagedWidget ("report", asciiTextWidgetClass, box, args, 5);
#else
		XtSetArg (args[0], XtNeditType, XttextEdit);
	XtSetArg (args[1], XtNtextOptions, resizeWidth | resizeHeight | scrollVertical | scrollHorizontal | scrollOnOverflow | editable);
	XtSetArg (args[2], XtNlength, 20000);
	XtSetArg (args[3], XtNheight, 150);
	XtSetArg (args[4], XtNwidth, 400);   /* !!! Should maybe be elsewhere */
	Report_widget =  XtCreateManagedWidget ("report", asciiStringWidgetClass, box, args, 5);
#endif
}


/*************************************************************************/
/*  Popup the report and start */
/*************************************************************************/

CALLBACK(SetReportWidgetCB)
	String w_name = (String) client_data;

	Widget text_widget;
	String name;
	char  clean_name[1024]; /* !!! */

	if (w_name == NULL) {
		user_error ("Messages text widget name is NULL");
		return;
	}
	WcCleanName (w_name, clean_name);
	if ( !toplevel) {
		sys_error ("Toplevel widget is NULL");
		return;
	}
	text_widget = WcFullNameToWidget (toplevel, clean_name);
	if ( ! text_widget) {
		user_error ("No such text widget [%s]", clean_name);
		return;
	}
	if ( ! XtIsSubclass (text_widget, textWidgetClass)) {
		user_error ("Report Widget [%s] is not an text widget", clean_name);
		return;
	}
	(void) set_write_report_routine (xio_write_report);
	Report_widget = text_widget;
ENDCB

/*************************************************************************/
/*************************************************************************/
/*  $Header$  */
/*************************************************************************/
/*************************************************************************/


