.TH MONET 1N
.\" $Header$
.\"
.\"
.\" $Log$
.SH NAME
.TP
.B monet
\- a generic, distributed network Mapping, Monitoring and Management Workstation
.SH SYNOPSIS
Monet is a generic tool for distributed gathering and viewing computer network
statistics and toplogies.
.PP
The code is written in C for Unix(BSD), the mapper requires
X11R4.  Protocols supported are IP/TCP/X25/SNMP.  Much
work is needed on the monitor.  Output is on the command line,
X or to postscript.
.PP
Imake is used to create the makefiles, if you don't have it
you can get it from the X11R4 release or simply by asking
around.
.PP
The software has been developed and tested on an
Apollo SR10.2 /BSD4.3 with X11R4, but a number of other
systems have been used during development, including
a DECStation 3100/ Ultrix, Sun, Gould/NP1, and a Silicon
Graphics Iris.

.SH DESCRIPTION
.PP
Monet is a set of programs for monitoring and mapping
multiprotocol (Wide Area) Computer Networks.  It tries
to be generic by allowing users to add new
types of network object without writing new code and by isolating
protocol specific modules.
.PP
A set of distributed agents collect and cook data,
answer queries directly or chain requests on to other agents.
Non-statistical information or statistical data from other sources can
be loaded into running agents.  A client based on X and a command line
client are avaliable, as are some scripts for producing maps.
.PP
Currently the software consists of an X11 based mapping
program and a network database/monitoring agent.  The monitoring
program does all the logging and can support multiple
clients, it requires no X11.  There is also a command line
version of the client and a program for loading the \fIdatabase /
monitoring\fR agent while it is running.
.PP
Maps can be built fairly easily using a reasonably powerful graphics editor is available
to build the maps interactively.  There are also some tools built in
and some scripts for auto-discovery and for automatic layout.
.PP
Changes in network status are automatically shown. In addition it is quite
easy to use external programs and their output with \fImonet\fR.
.PP
The maps can be saved locally or
in a remote repositary so that other people can share them.  The status
and topology information is stored separately from the maps, in a local
file or in the monitoring agents.

.SH INSTALLATION

You should be able to get the compressed distribution \fImonet.tar.Z\fR
from \fInikhefh.nikhef.nl\fR.  Once you have it on your machine use
the following command to get the source directory.
.TP 4
.B zcat monet.tar.Z | tar -xf -
.TP 4
.B cd monet
.TP 4
.B xmkmf
.TP 4
.B make Makefiles
.TP 4
.B make
.PP
Monet uses \fIimake (1)\fR to create system specific makefiles.
You should first edit \fIMonet.tmpl\fR
to set things up for your local system.  In addition
you should edit \fImonet/lib/wcl/Wc.tmpl\fR.  If
you cannot get imake to work then try editing the
existing makefiles by hand.
Imake is available with the X(1) windowing system.
.PP
At the time of writing Apollo and Digital distributed only
X11 Release 3 libraries.  The Monet software requires X11
Release 4.
This is not a problem because it is pretty easy to compile
MIT release 4 software and just use the client libraries.
Just ftp tape one from a convenient server, mcsun.eu.net
for example.  The libraries must be created with X11 Release 3
.PP
X.25 support varies greatly from machine to machine and so needs to
be implemented especially for each.  Currenly Apollo and Gould-NP1
is supported, but it should be simple enough for other types.

.SH CUSTOMIZATION
You should look at \fBmonet/bin/xmonet/XMonet.ad\fR for customizing the
X interface and also for specifying external commands like
ping, traceroute, snmpget etc.  These will probably be somewhere else
on your system and you will want to include your own commands too.
Comments are included in the file.


.SH OVERVIEW

.TP 4
.B monetd
\-
you may wish to run more than one of these agents,
they are used for network monitoring.  Clients like \fImonetd\fR
and \fIxmonet\fR can connect to them and have the network status
shown as it changes.  The agents can also talk to each other so that
all requests for a particular type of query or queries for a particular
domain can be done by an agent close to the systems being monitored.
The system in fact maintains a distributed network entity database
including the network topology.  This can maintain any number of
classes of entity although it may be able to monitor a small subset of
them.
.TP 4
.B xmonet
\-
this is an X windows based system for creating network
and viewing network maps.  It includes a reasonably powerful editor,
tools for building the maps, remote access to maps, can view network status
in real time and can work with scripts and other programs.  The output
of these programs or shell scripts can be displayed in a window or used
as instructions for \fIxmonet\fR.  Maps can be displayed within each other
allowing a zoom facility.  
The system and user interface are quite configurable.
.TP 4
.B monetsh
\-
this is a command line version of \fIxmonet\fR,
and provides much the same functionality.  It includes a very basic
query/script language and so can be used in shell scripts to perform
batch processing of network information.
.TP 4
.B monetdload
\-
this utility is used to send new data to a running
\fImonetd\fR agent.  One use would be to get networking information
from some existing monitoring tool, massage the format into that usable
by monet and then load the information making it available to anyone
using the system.
.TP 4
.B monetmapd
\-
this daemon allows remote access to a set of map
files.  The idea is that once a map is completed it is deposited
in one place for use by everyone else.  There should be such
a server running on \fInikhefh.nikhef.nl\fR.  The maps can be
read, written and listed using \fImonetd\fR or \fIxmonet\fR.
.TP 4
.B rping
\-
This is derived from \fIping(1)\fR but only does one ping at a
time.  It is used by \fImonetd\fR for queries.
.TP 4
.B layout
\-
this program takes a network and tries to lay it out nicely in
2D.  It is far from perfect but takes an awful lot of the work
out of doing it by hand.  At the time of writing it has not been
integrated into \fImonetsh\fR or \fIxmonet\fR but this will not
require a lot of work.  The could be a very useful program for
producing maps of arbitrary bits of a network.
.TP
.B makemaps
\-
This is a script for producing a network topology database for
a set of domains.  It looks in the nameserver and tries to identify
those machines it thinks are the most important.  Not very effective
currently but could be made very powerful.
.TP
.B snmp*
\-
these are part of the CMU SNMP distribution, they are included here
because they are called by \fIxmonet\fR.  In addition they have been
altered slightly.

.SH OPTIONS
Options can be set in configuration files or on the command line
and are the same for all of the programs although some may not be used.
For a complete list and description use \fImonetsh -help 2\fR.
.PP
On start up the system configuration file is read \fIetc/monet/monetrc\fR
followed by \fI~/.monetrc\fR.  Command line options are read twice, before
and after the config files.  In addition two more config files will be
read if they exist \fI/etc/monet/<program_name>rc\fR and
\fI~/.<program_name>rc\fR.

.SH COPYRIGHT
Copyright (C) 1991  NIKHEF-H Kruislaan 409, 1009DN Amsterdam, The Netherlands
.PP
Monet is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 1.
.PP
Monet is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
.PP
You should have received a copy of the GNU General Public License
along with Monet; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
.PP
For more information please contact James Barr or Rob Blokzijl at
PP
NIKHEF-H, Kruislaan 409, 1009DB Amsterdam, The Netherlands
.PP
or a38@nikhef.nl, k13@nikhef.nl

.SH FILES
 /etc/monet/* \- basic directory
.br
~/.monetrc - User configuration file.
.br
/etc/monet/monetrc - System configuration file.
.br
/etc/monet/x25hosts - X.25 address translation table.
.br
/etc/monet/mib.txt - SNMP MIB File in rfc format.
.br
/etc/monet/monetd.conf - default list of queries for monetd.
.br
/etc/monet/maps.PS - Postscript Prolog for maps.
.br
/etc/monet/class.edb - default definition of entity classes.
.br
/etc/monet/class.edb - default entity database.
.br
/etc/monet/maps - default map file directory.
.br
/etc/monet/log - default logging directory.

.SH "SEE ALSO"
.br
xmonet(1N), monetsh(1N), monetdload(1N),
monetd(8N), monetmapd(8N), X(1),
.SH AUTHOR
James Barr, NIKHEF-H, Amsterdam

